// Répertoire de travail
PATH = get_absolute_file_path("Cube_Color_Browser.sce");
chdir(PATH);
exec("Set_Language.sci");
global fg;global hs1;global hs2;global hs3;
lines(0);global Colors;global index1;
global Etat;Etat="Clear"; // Etats du GUI : Clear - Cube - Sel1 - Sel2
load('Cube.dat','G_Data','V_Data');

////////////////////////////////////////////////////// Choix du language ////////////////////////////////////////////////////
Language=Set_Language();

if Language=="F" then                               // Français
   titre_fg= "Toutes les couleurs dans un cube ...";
  t_n="Noir";
  t_bl="Blanc";
  t_r="Rouge";
  t_g="Vert";
  t_b="Bleu";
  t_cl="Couleurs RGB : ';
  t_rb1=' Noir / Blanc';
  t_rb2=' Vert / Rose';
  t_rb3=' Bleu / Jaune';
  t_rb4=' Rouge / Turquoise';
  t_p=' Rose';t_y=' Jaune';t_t='Turquoise';t_cube="Une couleur est représentée par un point du cube";
  i_cube="Dessin du cube en cours ...";i_clic="Sélectionner une couleur par un clic";
  i_sld="Cliquer sur le bouton =>Go";i_Sel1=("Cliquer sur l''échelle de tonalité ou sur une autre couleur");
  t_et="Vous pouvez explorer le cube des couleurs par l''une des 4 diagonales ci-dessous :";
  i_fig="Cliquer sur l''image pour continuer !";
  
else;                                                    // US
    titre_fg= "All colors in a solid cube ...";
    t_n="Black";
    t_bl="White";
    t_r="Red";
    t_g="Green";
    t_b="Blue";
    t_cl="RGB Colors are : ";
    t_rb1=' Black / White';
    t_rb2=' Green / Pink';
    t_rb3=' Blue / Yellow';
    t_rb4=' Red / Turquoise';
    t_p=' Pink';t_y=' Yellow';t_t='Turquoise';t_cube="Each color is a point of the solid cube";
    i_cube="Drawing in progress, please wait ...";i_clic="Click to select a color";
    i_sld="Click on =>Go Button";i_Sel1=("Click on tone scale or on another color");
    t_et="You can explore the solid colors Cube by one of the 4 diagonal lines (select below) :";
    i_fig="Click to continue !"
end

/////////////////////////////////////////// Image du cube //////////////////////////////////////////////////////////////////
load("cube.fig");f=gcf();f.figure_name = t_cube;
f.figure_position = [401,37];xinfo(i_fig);
xclick();
close(f);

//////////////////////////////////////////  Définitions des fonctions utilisées /////////////////////////////////////////////
function C_RB1 ();  // gestion radiobutton
    if rb1.value==1 then
        set(rb2,'value',0);set(rb3,'value',0);set(rb4,'value',0);
        set(tn,'BackgroundColor', [0.8,0.8,0.8]);
        set(tb,'BackgroundColor', [0.8,0.8,0.8]);
        set(tn,'string',t_n);set(tb,'string',t_bl);C_Go;
    end
endfunction

function C_RB2 ();  // gestion radiobutton
    if rb2.value==1 then
        set(rb1,'value',0);set(rb3,'value',0);set(rb4,'value',0);
        set(tn,'BackgroundColor', [0,1,0]);
        set(tb,'BackgroundColor', [1,0,1]);
        set(tn,'string',t_g);set(tb,'string',t_p);C_Go;
    end
endfunction

function C_RB3 ();  // gestion radiobutton
    if rb3.value==1 then
        set(rb2,'value',0);set(rb1,'value',0);set(rb4,'value',0);
        set(tn,'BackgroundColor', [0,0,1]);
        set(tb,'BackgroundColor', [1,1,0]);
        set(tn,'string',t_b);set(tb,'string',t_y);C_Go;
    end
endfunction

function C_RB4 ();  // gestion radiobutton
    if rb4.value==1 then
        set(rb2,'value',0);set(rb3,'value',0);set(rb1,'value',0);
        set(tn,'BackgroundColor', [1,0,0]);
        set(tb,'BackgroundColor', [0,1,1]);
        set(tn,'string',t_r);set(tb,'string',t_t);C_Go;
    end
endfunction

function set_Lum(); // Réglage luminosité
    global Etat;
    // mise à jour suite à une valeur donnée par le slider
  set(t_Lum,'string',"  "+string(sld.value));
  if ~(Etat=="Clear") then xfrect(-12,12,44,24); b=get('hdl');b.background=color(153,153,255); // effacement zone graphique
      xinfo(i_sld);Set_C(["","",""]);
  end
  Etat="Clear";S_CL;
endfunction

function S_CL();  // Affichage couleur de luminosité
    C=sld.value*255/100;
    if rb1.value==1 then R=C;G=C;B=C;
    end
     if rb2.value==1 then R=C;G=255-C;B=C;
    end
     if rb3.value==1 then R=C;G=C;B=255-C;
    end
     if rb4.value==1 then R=255-C;G=C;B=C;
    end
    xfrect(-35.8,0.42,4.3,2.6);b=get('hdl');b.background=color(R,G,B);
endfunction

function C_Go();
    global Etat;
    Set_C(["","",""]);
    dess_cube;
    Etat='Cube';xinfo(i_clic);
endfunction

function dess_cube;
    xinfo(i_cube);
    xfrect(-12,12,44,24); b=get('hdl');b.background=color(153,153,255); // zone graphique
    M=G_Data(sld.value);s=size(M);nb=s(1);S_CL;
    for i=1:nb;
         if rb1.value==1 then Diag=1;
        end
         if rb2.value==1 then Diag=2;
        end
         if rb3.value==1 then Diag=3;
        end
         if rb4.value==1 then Diag=4;
        end
        select Diag;
        case 1 then xfrect(M(i,1),M(i,2),1,1);b=get('hdl');b.background=color(M(i,3),M(i,4),M(i,5)); // Noir - Blanc
        case 2 then xfrect(M(i,1),M(i,2),1,1);b=get('hdl');b.background=color(M(i,3),255-M(i,4),M(i,5)); // Vert - Rose
        case 3 then xfrect(M(i,1),M(i,2),1,1);b=get('hdl');b.background=color(M(i,3),M(i,4),255-M(i,5)); // Bleu - Jaune
        case 4 then xfrect(M(i,1),M(i,2),1,1);b=get('hdl');b.background=color(255-M(i,3),M(i,4),M(i,5)); // Rouge - Turquoise
        end    
    end
endfunction

function Lt=Tonal(C);
    //  donne 10 tonalités à partir d'une couleur
    // C = matrice [R G B]
    // Lt = liste des 10 tonalités : Lt(1) la plus sombre    Lt(10) la plus claire
    // Lt(i) =  [R G B]
    T=gsort(C);
    if T(1)==0 then T(1)=1;
    end
    r=255/T(1);  
    Lt=list();
    for i=1:10;A=r*i*C/10;
        Lt($+1)=int(A);
    end
endfunction

function dess_ton(A);
    Lt=Tonal(A);
    for t=1:10;
        M=Lt(t);
        xfrect(14,10-(2*(t-1)),2,2);b=get('hdl');b.background=color(M(1),M(2),M(3));
    end
endfunction

function Position(win,x,y,ibut);   // Suite à un clic de souris dans la zone graphique
   global hs1;global hs2;global hs3;global Etat;global Colors;global index1;
   if ibut==3 & ~(Etat=="Clear") then
    [x,y]=xchange(x,y,'i2f');x=round(x-0.5);y=round(y+0.5);
    
     if x<11 & x>-11 & y<10 & y>-10 then // zone de première sélection
         M=V_Data(sld.value);
         if  M(x+11,y+10)==1 then
        delete(hs1);
        xrect(x,y,1,1);hs1=get('hdl');Etat='Sel1';
        xinfo(i_Sel1);
        M=G_Data(sld.value);s=size(M);nb=s(1);
        for c=1:nb; // recherche de la couleur sélectionnée
            if M(c,1)==x & M(c,2)==y then i=c;index1=c;
            end
        end
        xfrect(20,10,8,20);b=get('hdl');// rectangle d'affichage de la couleur sélectionnée
         if rb1.value==1 then Diag=1;
        end
         if rb2.value==1 then Diag=2;
        end
         if rb3.value==1 then Diag=3;
        end
         if rb4.value==1 then Diag=4;
        end
        select Diag;
        case 1 then b.background=color(M(i,3),M(i,4),M(i,5)); // Noir - Blanc
           RGB=[M(i,3),M(i,4),M(i,5)] ; 
        case 2 then b.background=color(M(i,3),255-M(i,4),M(i,5)); // Vert - Rose
           RGB=[M(i,3),255-M(i,4),M(i,5)] ;
        case 3 then b.background=color(M(i,3),M(i,4),255-M(i,5)); // Bleu - Jaune
           RGB=[M(i,3),M(i,4),255-M(i,5)] ;
        case 4 then b.background=color(255-M(i,3),M(i,4),M(i,5)); // Rouge - Turquoise
           RGB=[255-M(i,3),M(i,4),M(i,5)] ;
        end  
        Set_C(string(RGB));
        xfrect(12,10,2,20);b=get('hdl');b.background=color(153,153,255);
        xfrect(16,10,2,20);b=get('hdl');b.background=color(153,153,255);
        xrect(20,10,8,20);dess_ton(RGB); // échelle de tonalité
        Colors=RGB;index1=RGB;
        end
     end
     
     if (x<17 & x>11 & (Etat=='Sel1' | Etat=='Sel2')) then ;// zone de deuxième sélection
       if y<11 & y>-10 then
           delete(hs2);delete(hs3);Etat='Sel2';index2=(round((y+10)/2));y=(2*(int(y/2)));
           xfrect(12,y,2,2);hs2=get('hdl');
           xfrect(16,y,2,2);hs3=get('hdl');
           C2=Tonal(index1);RGB=C2(11-index2);
           xfrect(20,10,8,20);b=get('hdl');// rectangle d'affichage de la couleur sélectionnée
           b.background=color(RGB(1),RGB(2),RGB(3));xrect(20,10,8,20)
           Set_C(string(RGB));Colors=RGB;
       end   
     end
   end
endfunction

function Set_C(C); // Affiche les 3 composantes
    set(tvr,'string',C(1));set(tvg,'string',C(2));set(tvb,'string',C(3));
endfunction

function C_OK;
    if Etat=='Sel1' | Etat=='Sel2' then
        disp(string(Colors),t_cl);
    end
endfunction
    
////////////////////////////////////////////  Création de l'interface graphique //////////////////////////////////////////////
fg=figure('backgroundcolor',[0.59  0.96 .99],'figure_name',titre_fg);
fg.figure_position = [401,37];
fg.axes_size = [640,440];
fg.children.data_bounds = [-28,-20;36,24];
fg.children.isoview = "on";
// Control Slider
sld=uicontrol('Parent',fg,'style','slider','MIN',1,'Max',100,'Position',[80,120,20,160],'callback',"set_Lum"); 
t_Lum=uicontrol('Parent',fg,'style','text','string',"  "+string(sld.value),'Position',[40,200,30,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center');
tn=uicontrol('Parent',fg,'style','text','string',t_n,'Position',[60,300,60,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center');
tb=uicontrol('Parent',fg,'style','text','string',t_bl,'Position',[60,80,60,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center');
tgo=uicontrol('Parent',fg,'style','pushbutton','string',"=> Go",'Position',[120,200,60,20],'FontWeight','bold','FontSize',15,'callback','C_Go');
xfrect(-12,12,44,24); // zone graphique
b=get('hdl');b.background=color(153,153,255);
// Affichage des couleurs :
fr=uicontrol(fg,'style','frame','Position',[150,10,460,60]);
ttr=uicontrol('Parent',fr,'style','text','string',t_r,'Position',[20,30,60,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center');
ttg=uicontrol('Parent',fr,'style','text','string',t_g,'Position',[140,30,60,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center');
ttb=uicontrol('Parent',fr,'style','text','string',t_b,'Position',[260,30,60,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center');
tvr=uicontrol('Parent',fr,'style','text','string',"",'Position',[20,10,60,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center','backgroundcolor',[1 0.2 0.2]);
tvg=uicontrol('Parent',fr,'style','text','string',"",'Position',[140,10,60,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center','backgroundcolor',[0.4 1 0.4]);
tvb=uicontrol('Parent',fr,'style','text','string',"",'Position',[260,10,60,20],'FontWeight','bold','FontSize',15,'HorizontalAlignment','center','backgroundcolor',[0.2 0.4 1]);
// Bouton OK
tok=uicontrol('Parent',fr,'style','pushbutton','string',"OK",'Position',[380,10,60,40],'FontWeight','bold','FontSize',20,'HorizontalAlignment','center','backgroundcolor',[0.6 0.4 1],'callback','C_OK');
// Affichage entete
fr2=uicontrol(fg,'style','frame','Position',[40,330,580,80]);
tet=uicontrol('Parent',fr2,'style','text','string',t_et,'Position',[20,50,520,20],'FontWeight','bold','FontSize',12);
rb1=uicontrol('Parent',fr2,'style','radiobutton','Position',[20,10,20,20],'callback','C_RB1');
rb2=uicontrol('Parent',fr2,'style','radiobutton','Position',[160,10,20,20],'callback','C_RB2');
rb3=uicontrol('Parent',fr2,'style','radiobutton','Position',[300,10,20,20],'callback','C_RB3');
rb4=uicontrol('Parent',fr2,'style','radiobutton','Position',[440,10,20,20],'callback','C_RB4');

trb1=uicontrol('Parent',fr2,'style','text','string',t_rb1,'Position',[40,10,100,20],'FontWeight','bold','FontSize',12);
trb2=uicontrol('Parent',fr2,'style','text','string',t_rb2,'Position',[180,10,100,20],'FontWeight','bold','FontSize',12);
trb3=uicontrol('Parent',fr2,'style','text','string',t_rb3,'Position',[320,10,100,20],'FontWeight','bold','FontSize',12);
trb4=uicontrol('Parent',fr2,'style','text','string',t_rb4,'Position',[460,10,110,20],'FontWeight','bold','FontSize',12);

///////////////////////////////////////////// Initialisations /////////////////////////////////////////////////////
set(rb1,'value',1);  // Diag = 1 (Noir/Blanc)
set(sld,'value',58);set(t_Lum,'string',"  "+string(sld.value));S_CL;C_Go; // dessin du cube
xrect(0,0,1,1);hs1=get('hdl');set(hs1,'visible',"off"); // carré de 1ere sélection
xrect(12,0,2,2);hs2=get('hdl');set(hs2,'visible',"off"); // carré de 2eme sélection
xrect(16,0,2,2);hs3=get('hdl');set(hs3,'visible',"off"); // carré de 2eme sélection

seteventhandler('Position') ; // attente clic dans zone graphique
